<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-item label="组织代码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['orgId']" placeholder="请输入组织代码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="调拨单编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['allotCode']" placeholder="请输入调拨单编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="源仓库编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['srcStoreCode']" placeholder="请输入源仓库编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="目的组织代码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['toOrgId']" placeholder="请输入目的组织代码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="目的仓库编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['toStoreCode']" placeholder="请输入目的仓库编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="调拨类型" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['allotType']" placeholder="请输入调拨类型"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="出库规则" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['flRule']" placeholder="请输入出库规则"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="是否超调拨" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['isOfAllot']" placeholder="请输入是否超调拨"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="物料编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['mtrlCode']" placeholder="请输入物料编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="调拨数量" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input-number v-decorator="['allotQty']" placeholder="请输入调拨数量" style="width: 100%"/>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="SKU编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['skuCode']" placeholder="请输入SKU编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="批次" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['lotno']" placeholder="请输入批次"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="出库粒度" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['plDay']" placeholder="请输入出库粒度"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="备注" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['remark']" placeholder="请输入备注"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="主键ID" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fid']" placeholder="请输入主键ID"></a-input>
            </a-form-item>
          </a-col>
          <a-col v-if="showFlowSubmitButton" :span="24" style="text-align: center">
            <a-button @click="submitForm">提 交</a-button>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'

  export default {
    name: 'ImsWmsAllotForm',
    components: {
      JFormContainer,
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：true流程表单 false普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        form: this.$form.createForm(this),
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
        },
        url: {
          add: "/ras/imsWmsAllot/add",
          edit: "/ras/imsWmsAllot/edit",
          queryById: "/ras/imsWmsAllot/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      add () {
        this.edit({});
      },
      edit (record) {
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'orgId','allotCode','srcStoreCode','toOrgId','toStoreCode','allotType','flRule','isOfAllot','mtrlCode','allotQty','skuCode','lotno','plDay','remark','fid'))
        })
      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          });
        }
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'orgId','allotCode','srcStoreCode','toOrgId','toStoreCode','allotType','flRule','isOfAllot','mtrlCode','allotQty','skuCode','lotno','plDay','remark','fid'))
      },
    }
  }
</script>